package com.example.switchyard.jorge;

import org.switchyard.component.bean.Reference;
import org.switchyard.component.bean.Service;

import com.example.switchyard.jorge.jaxb.*;
import com.google.inject.Inject;

@Service(VideoDownloader.class)
public class VideoDownloaderBean implements VideoDownloader {

	@Inject @Reference("LoggingRoute")
	protected LoggingRoute route;
	
	@Override
	public DownloadDetails download(VideoDetails details)
			throws VideoDownloaderException {
		System.out.println("--------  EXECUTING SERVICE");
		System.out.println("----- PARAMS: " + details);
		DownloadDetails download = new DownloadDetails();
		if (details.getUsername()!=null && details.getUsername().equals("jorge")){
			download.setDirName("jorge");
			if (route!=null){
				route.process(download);
			}else{
				System.out.println("------------ ROUTE IS NULL. IT HAS NOT BEEN INJECTED");
			}
		}else{
			if (details.getTimeout()<0){
				throw new VideoDownloaderException("Timeout can not be less than 0");
			}
		}
			
		return download;
	}

}
