package com.example.switchyard.jorge;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.switchyard.component.test.mixins.cdi.CDIMixIn;
import org.switchyard.test.Invoker;
import org.switchyard.test.ServiceOperation;
import org.switchyard.test.SwitchYardRunner;
import org.switchyard.test.SwitchYardTestCaseConfig;
import org.switchyard.test.SwitchYardTestKit;

import com.example.switchyard.jorge.jaxb.DownloadDetails;
import com.example.switchyard.jorge.jaxb.VideoDetails;

@RunWith(SwitchYardRunner.class)
@SwitchYardTestCaseConfig(config = SwitchYardTestCaseConfig.SWITCHYARD_XML, mixins = { CDIMixIn.class })
public class VideoDownloaderTest {

	private SwitchYardTestKit testKit;
	
	private CDIMixIn cdiMixIn;
	
	@ServiceOperation("VideoDownloader")
	private Invoker service;

	@Test
	public void testDownload() throws Exception {
		// TODO Auto-generated method stub
		// initialize your test message
		VideoDetails message = new VideoDetails();
		message.setUsername("jorge");
		
		DownloadDetails result = service.operation("download")
				.sendInOut(message).getContent(DownloadDetails.class);

		// validate the results
		Assert.assertTrue(result.getDirName().equals("jorge"));
	}

}
